#include <bits/stdc++.h>

using namespace std;


int main()
{
    typedef long long ll;
    ll n,m;
    ios::sync_with_stdio(false); cin.tie(NULL);cout.tie(NULL);
    ll t;
    cin>>t;
    for(ll i=0;i<t;i++)
    {
        bool p=true;
        ll n,m;
        cin>>n>>m;
        ll a[n],b[m];
        for(ll i=0;i<n;i++) cin>>a[i];
        for(ll i=0;i<m;i++) cin>>b[i];
        sort(a,a+n);sort(b,b+m);
        ll x=a[1]-a[0];
        for(ll i=2;i<n;i++)
        {
            if(x>a[i]-a[i-1]) x=a[i]-a[i-1],i=0;
        }
        for(ll i=0;i<n&&p;i++)
        {
            if((a[n-1]-b[i])%x==0)
                p=false;
        }
        if(p) cout<<1<<"\n";
        else cout<<0<<"\n";
    }
}